/*
 *
 *	@(#)node.h	1.16	94/03/06	(c) PACT
 *
 *	PACT Parallel C / transputer
 *
 *	Copyright (c) 1991-1994 PACT
 *	All Rights Reserved
 *
 */

#ifndef	__node_included
#define	__node_included


#include	"config.h"


#ifndef	LINK0OUT
#define	LINK0OUT	((void |*) 0x80000000)
#define	LINK1OUT	((void |*) 0x80000004)
#define	LINK2OUT	((void |*) 0x80000008)
#define	LINK3OUT	((void |*) 0x8000000C)
#define	LINK0IN		((void |*) 0x80000010)
#define	LINK1IN		((void |*) 0x80000014)
#define	LINK2IN		((void |*) 0x80000018)
#define	LINK3IN		((void |*) 0x8000001C)
#define	LINKEVENT	((void |*) 0x80000020)
#endif
#ifndef	LINKxOUT
#define	LINKxOUT(x)	(LINK0OUT + (x))
#define	LINKxIN(x)	(LINK0IN  + (x))
#endif


#ifndef	__sem_t_defined
typedef	struct {
	int	value;
	int	*sf;
	int	*sb;
} sem_t;
#define	__sem_t_defined
#endif


extern	struct _Node {
	int					id;				/* node id */
	int					devtype;		/* device type */
	int					devid;			/* device id */
	int					cpus;			/* flags indicating processor capabilities */
	unsigned char		server;			/* server version * 10 (+ 100 if pserver) */
	unsigned char		host;			/* host computer */
	unsigned char		OS;				/* host OS */
	unsigned char		board;			/* interface board */
	CHAN				*toserver;		/* channel to server */
	CHAN				*fromserver;	/*    and from server */
	sem_t				serversem;		/* semaphore to guard this channel */
	void				*memstart;		/* start of memory */
	struct _Process		*process;		/* configurer's Process structure */
} _Node;


#if	__STDC__
#	define	_P(x)	x
#else
#	define	_P(x)	()
#endif

int		__lddevid _P((int *, int *));
void	__serverid _P((void));
int		__clargs _P((char ***));
void	*getparm _P((int));

#undef	_P


#endif	/* __node_included */

