.so man.macros
.HS vcprecv tk 
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
vcprecv \- Receive a message from a virtual/physical channel
.SH SYNOPSIS
\fBvcprecv \fIvchan header\fR ?\fIoptions\fR?
.PP
\fBvcprecv \fIlink count\fR ?\fIoptions\fR?
.BE

.SH OPTIONS
.IP "\fB\-data \fIdata\fR" 15
Store the message received in the Tcl variable \fIdata\fR. The
message is stored in the format \fIelement\fR?.\fIelement\fR. \fI... element\fR? .
Each element in this string is a hexadecimal number preceded by 0x and 
represents one byte of the message.
.IP "\fB\-file \fIfilename\fR" 15
Receive the message in the file specified by \fIfilename\fR.
.IP "\fB\-bind \fIcommand\fR" 15
Perform a non\-blocking receive and execute the Tcl/Tk command specified in 
\fIcommand\fR when the receive is complete.
.IP "\fB\-timeout \fItime command\fR" 15
If the receive command cannot be completed in the number of microseconds specified by
\fItime\fR, abort the command and execute the Tcl/Tk command specified
by \fIcommand\fR.

.SH DESCRIPTION
.PP
This command is used to receive a message over a virtual channel or a
physical link. When a message is to be received from a virtual channel,
\fIvchan\fR specifies the virtual channel address and is of the form
\fIlink\fR.\fIsubheader\fR. The subheader is a decimal number, and is assumed 
to be a two\-byte header, if its value is greater than 255 or if it starts with 
a zero.  Otherwise it is assumed to be a single\-byte header. \fIlink\fR can take
values l0, l1, l2 and l3.  \fIheader\fR specifies the virtual channel address 
where the acknowledgement is to be sent.It is of the form 
?\fIlink\fR.?\fIsubheader\fR?.\fIsubheader ...\fR ?. The message is expected in the
format used by C100.  The command is complete when a packet is received with
the EndOfMessage flag, and the acknowledgement of that packet is sent.
Virtual VCP should be initialized by running \fIvcpinit\fR on \fIlink\fR before 
this call is made.
.PP
When a message is to be received over a physical channel, \fIlink\fR specifies
the linknumber over which the message should be received. \fIcount\fR specifies
the number of bytes that are to be received. The command is complete
when \fIcount\fR bytes are received over \fIlink\fR.

.SH SEE ALSO
run, vcpsend, inspect
