/*	Definitions used by VCP
*/

#ifndef VCP_VCPDEFS_H
#define VCP_VCPDEFS_H

#ifndef	NULL
#define	NULL	(void *)0
#endif

/*	Number of links on the transputer
*/
#define	NUM_LINKS		4

/*	Number of ticks per second for a high priority thread
*/
#define	TICKS_PER_SECOND	1000000
#define	TICKS_PER_MILLISEC	1000

/*	Maximum length of virtual channel address
*/
#define	MAX_HEADER_SIZE		2

/*	Maximum data bytes in a packet
*/
#define	MAX_PACKET_DATA		32

/*	Maximum size of any packet received
*/
#define	MAX_PACKET_SIZE		MAX_PACKET_DATA + MAX_HEADER_SIZE

/*	Minimum size of any packet received :	 <Count><Header> 
*/
#define	MIN_MESSAGE_SIZE	1


/*	Minimum size of a packet sent by C100
*/
#define	MIN_PACKET_SIZE		8

/*	Bit number of EOM flag in the first byte of a packet sent by C100
*/
#define	EOM_BIT_NUMBER		7

/*	Mask used to obtain packet length from the first byte of a packet
	sent by C100
*/
#define COUNT_MASK		0x7f

/*	Mask used to obtain EOM flag from the first byte of a packet
	sent by C100
*/
#define EOM_MASK		0x80

/*	Stack size for all VCP threads
*/
#define	DEFAULT_STACKSIZE	4096*4


/*	Size of all table structures used by VCP. Should not be changed
	as long as different sized keys are being used, since entries are
	made without checking for the size of the key.
*/
#define	MAX_TABLE_SIZE		256




/*	Possible Error definitions
*/

#define		VCP_OK			1
#define		PacketTooLong		-1
#define		PacketTooShort		-2
#define		UnExpectedPacket	-3
#define		UnExpectedAck		-4
#define		OutOfMemory		-5
#define		InternalError		-6
#define		VCPNotInitialized	-7
#define		IllegalLinkNumber	-8
#define		VCP_ReceiveAllSet	-9
#define		VCP_TimeOut		-10
#define		VCP_AlreadyRunning	-11
#define		CannotOpenFile		-12

#endif
